﻿-- GLOBALS: GetCurrencyListInfo, GetCurrencyListSize, GetPVPRewards, GetStatistic, RequestPVPRewards, string, TogglePVPFrame, tonumber, UnitLevel

----------------------------- Icons, lib and onclick  ------------------------------

local PvPinfo_icon = ""
	if UnitFactionGroup("player") == "Alliance"
	then PvPinfo_icon = "Interface\\Icons\\Achievement_pvp_a_16"
	else PvPinfo_icon = "Interface\\Icons\\Achievement_pvp_h_16"
	end
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local lqt = LibStub:GetLibrary('LibQTip-1.0')
local dataobj = ldb:NewDataObject("Broker_PvPinfo", {
    type = "data source",
    icon = PvPinfo_icon,
	label = "PvPinfo",
	text = "PvPinfo",
	name = "PvPinfo",
	OnClick = function(self, button)
		if not IsAddOnLoaded("Blizzard_PVPUI") then
		LoadAddOn("Blizzard_PVPUI")
		end
		PVPUIFrame_ToggleFrame()
	end
    }
)

-------------------- Weekly Conquest from Arena and Rated BG's --------------------

local PvPinfo_ConquestCurrecy_Now, PvPinfo_ConquestCurrecy_Cap, PvPinfo_ConquestArena_Now, PvPinfo_ConquestArena_Cap = 0, 0, 0, 0
local PvPinfo_ConquestRatedBGs_Now, PvPinfo_ConquestRatedBGs_Cap, PvPinfo_ConquestRandomBGs_Now, PvPinfo_ConquestRandomBGs_Cap = 0, 0, 0, 0
local eventFrame = CreateFrame("Frame")
eventFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
eventFrame:RegisterEvent("PVP_REWARDS_UPDATE")
eventFrame:SetScript("OnEvent", function(self, event)
	if event == "PVP_REWARDS_UPDATE" then
		if UnitLevel("player") >= 70 then
			local pointsThisWeek, maxPointsThisWeek, tier2Quantity, tier2Limit, tier1Quantity, tier1Limit, randomPointsThisWeek, maxRandomPointsThisWeek = GetPVPRewards()
			PvPinfo_ConquestCurrecy_Now = tonumber(pointsThisWeek) or 0
			PvPinfo_ConquestCurrecy_Cap = tonumber(maxPointsThisWeek) or 0
			PvPinfo_ConquestArena_Now = tonumber(tier1Quantity) or 0
			PvPinfo_ConquestArena_Cap = tonumber(tier1Limit) or 0
			PvPinfo_ConquestRatedBGs_Now = tonumber(tier2Quantity) or 0
			PvPinfo_ConquestRatedBGs_Cap = tonumber(tier2Limit) or 0
			PvPinfo_ConquestRandomBGs_Now = tonumber(randomPointsThisWeek) or 0
 			PvPinfo_ConquestRandomBGs_Cap = tonumber(maxRandomPointsThisWeek) or 0
		end
	else
		RequestPVPRewards()
	end
end)

--------------------------- function dataobj:OnEnter() ----------------------------

function dataobj:OnEnter()

--------------------------- Earned honor and conquest ----------------------------

	local PvPinfo_ConquestPointsCount, PvPinfo_HonorPointsCount = 0, 0
	if UnitLevel("player") >= 10 then
		for i=1, GetCurrencyListSize() do 
			local name, _, _, _, _, count = GetCurrencyListInfo(i)
			string.find(name, "Honor Points")
			string.find(name, "Conquest Points")

			if name == "Conquest Points" then
				PvPinfo_ConquestPointsCount = count
			elseif name == "Honor Points" then
				PvPinfo_HonorPointsCount = count
			end
		end
	end
	
----------------------------- Battleground Statistics -----------------------------

	local PvPinfo_AlteracValley_Wins			= GetStatistic(49) == '--' and 0 or GetStatistic(49);
	local PvPinfo_AlteracValley_Totals			= GetStatistic(53) == '--' and 0 or GetStatistic(53);
	local PvPinfo_ArathiBasin_Wins				= GetStatistic(51) == '--' and 0 or GetStatistic(51);
	local PvPinfo_ArathiBasin_Totals			= GetStatistic(55) == '--' and 0 or GetStatistic(55);
	local PvPinfo_BattleForGilneas_Wins			= GetStatistic(5237) == '--' and 0 or GetStatistic(5237);
	local PvPinfo_BattleForGilneas_Totals		= GetStatistic(5236) == '--' and 0 or GetStatistic(5236);
	local PvPinfo_DeepwindGorge_Wins			= GetStatistic(8373) == '--' and 0 or GetStatistic(8373);
	local PvPinfo_DeepwindGorge_Totals			= GetStatistic(8374) == '--' and 0 or GetStatistic(8374);
	local PvPinfo_EyeOfTheStorm_Wins			= GetStatistic(50) == '--' and 0 or GetStatistic(50);
	local PvPinfo_EyeOfTheStorm_Totals			= GetStatistic(54) == '--' and 0 or GetStatistic(54);
	local PvPinfo_IsleofConquest_Wins			= GetStatistic(4097) == '--' and 0 or GetStatistic(4097);
	local PvPinfo_IsleofConquest_Totals			= GetStatistic(4096) == '--' and 0 or GetStatistic(4096);
	local PvPinfo_SilverShardMines_Wins			= GetStatistic(7830) == '--' and 0 or GetStatistic(7830);
	local PvPinfo_SilverShardMines_Totals		= GetStatistic(7829) == '--' and 0 or GetStatistic(7829);
	local PvPinfo_StrandOfTheAncients_Wins		= GetStatistic(1550) == '--' and 0 or GetStatistic(1550);
	local PvPinfo_StrandOfTheAncients_Totals	= GetStatistic(1549) == '--' and 0 or GetStatistic(1549);
	local PvPinfo_TempleOfKotmogu_Wins			= GetStatistic(7826) == '--' and 0 or GetStatistic(7826);
	local PvPinfo_TempleOfKotmogu_Totals		= GetStatistic(7825) == '--' and 0 or GetStatistic(7825);
	local PvPinfo_TwinPeaks_Wins				= GetStatistic(5233) == '--' and 0 or GetStatistic(5233);
	local PvPinfo_TwinPeaks_Totals				= GetStatistic(5232) == '--' and 0 or GetStatistic(5232);
	local PvPinfo_WarsongGulch_Wins				= GetStatistic(105) == '--' and 0 or GetStatistic(105);
	local PvPinfo_WarsongGulch_Totals			= GetStatistic(52) == '--' and 0 or GetStatistic(52);
	local PvPinfo_Battlegrounds_Wins			= PvPinfo_AlteracValley_Wins+PvPinfo_ArathiBasin_Wins+PvPinfo_BattleForGilneas_Wins+PvPinfo_DeepwindGorge_Wins+PvPinfo_EyeOfTheStorm_Wins+PvPinfo_IsleofConquest_Wins+PvPinfo_SilverShardMines_Wins+PvPinfo_StrandOfTheAncients_Wins+PvPinfo_TempleOfKotmogu_Wins+PvPinfo_TwinPeaks_Wins+PvPinfo_WarsongGulch_Wins;
	local PvPinfo_Battlegrounds_Totals			= PvPinfo_AlteracValley_Totals+PvPinfo_ArathiBasin_Totals+PvPinfo_BattleForGilneas_Totals+PvPinfo_DeepwindGorge_Totals+PvPinfo_EyeOfTheStorm_Totals+PvPinfo_IsleofConquest_Totals+PvPinfo_SilverShardMines_Totals+PvPinfo_StrandOfTheAncients_Totals+PvPinfo_TempleOfKotmogu_Totals+PvPinfo_TwinPeaks_Totals+PvPinfo_WarsongGulch_Totals;
	local PvPinfo_RatedBattlegrounds_Wins		= GetStatistic(5694) == '--' and 0 or GetStatistic(5694);
	local PvPinfo_RatedBattlegrounds_Totals		= GetStatistic(5692) == '--' and 0 or GetStatistic(5692);
	local PvPinfo_World1vs1_Wins				= GetStatistic(319) == '--' and 0 or GetStatistic(319);
	local PvPinfo_World1vs1_Lost				= GetStatistic(320) == '--' and 0 or GetStatistic(320);
	local PvPinfo_Arena2vs2_Wins				= GetStatistic(366) == '--' and 0 or GetStatistic(366);
	local PvPinfo_Arena2vs2_Totals				= GetStatistic(367) == '--' and 0 or GetStatistic(367);
	local PvPinfo_Arena3vs3_Wins				= GetStatistic(364) == '--' and 0 or GetStatistic(364);
	local PvPinfo_Arena3vs3_Totals 				= GetStatistic(365) == '--' and 0 or GetStatistic(365);
	local PvPinfo_Arena5vs5_Wins				= GetStatistic(362) == '--' and 0 or GetStatistic(362);
	local PvPinfo_Arena5vs5_Totals				= GetStatistic(363) == '--' and 0 or GetStatistic(363);
	local PvPinfo_Playerdeaths					= GetStatistic(60) == '--' and 0 or GetStatistic(60);
	local PvPinfo_HonorKills					= GetStatistic(588) == '--' and 0 or GetStatistic(588);
	local PvPinfo_CrittersKilled				= GetStatistic(108) == '--' and 0 or GetStatistic(108);
	local PvPinfo_SlashViolin					= GetStatistic(1067) == '--' and 0 or GetStatistic(1067);	
	
---------------------------------- Tooltip start ----------------------------------
	
	local tooltip = lqt:Acquire("PvPInfoTT", 4, "LEFT", "CENTER", "CENTER", "CENTER")
    self.tooltip = tooltip
    tooltip:AddLine('|cffFFC125Battleground','|cff71C671Won','|cffff6060Lost','|cff00E5EETotal')
	tooltip:AddLine('Alterac Valley',PvPinfo_AlteracValley_Wins,PvPinfo_AlteracValley_Totals-PvPinfo_AlteracValley_Wins,PvPinfo_AlteracValley_Totals)
	tooltip:AddLine('Arathi Basin',PvPinfo_ArathiBasin_Wins,PvPinfo_ArathiBasin_Totals-PvPinfo_ArathiBasin_Wins,PvPinfo_ArathiBasin_Totals)
	tooltip:AddLine('Battle for Gilneas',PvPinfo_BattleForGilneas_Wins,PvPinfo_BattleForGilneas_Totals-PvPinfo_BattleForGilneas_Wins,PvPinfo_BattleForGilneas_Totals)
	tooltip:AddLine('Deepwind Gorge',PvPinfo_DeepwindGorge_Wins,PvPinfo_DeepwindGorge_Totals-PvPinfo_DeepwindGorge_Wins,PvPinfo_DeepwindGorge_Totals)
	tooltip:AddLine('Eye of the Storm',PvPinfo_EyeOfTheStorm_Wins,PvPinfo_EyeOfTheStorm_Totals-PvPinfo_EyeOfTheStorm_Wins,PvPinfo_EyeOfTheStorm_Totals)
	tooltip:AddLine('Isle of Conquest',PvPinfo_IsleofConquest_Wins,PvPinfo_IsleofConquest_Totals-PvPinfo_IsleofConquest_Wins,PvPinfo_IsleofConquest_Totals)
	tooltip:AddLine('Silvershard Mines',PvPinfo_SilverShardMines_Wins,PvPinfo_SilverShardMines_Totals-PvPinfo_SilverShardMines_Wins,PvPinfo_SilverShardMines_Totals)
	tooltip:AddLine('Strand of the Ancients ',PvPinfo_StrandOfTheAncients_Wins,PvPinfo_StrandOfTheAncients_Totals-PvPinfo_StrandOfTheAncients_Wins,PvPinfo_StrandOfTheAncients_Totals)
	tooltip:AddLine('Temple of Kotmogu',PvPinfo_TempleOfKotmogu_Wins,PvPinfo_TempleOfKotmogu_Totals-PvPinfo_TempleOfKotmogu_Wins,PvPinfo_TempleOfKotmogu_Totals)
	tooltip:AddLine('Twin Peaks',PvPinfo_TwinPeaks_Wins,PvPinfo_TwinPeaks_Totals-PvPinfo_TwinPeaks_Wins,PvPinfo_TwinPeaks_Totals)
	tooltip:AddLine('Warsong Gulch',PvPinfo_WarsongGulch_Wins,PvPinfo_WarsongGulch_Totals-PvPinfo_WarsongGulch_Wins,PvPinfo_WarsongGulch_Totals)
    tooltip:AddLine(' ')
    tooltip:AddLine('|cffFFC125Overall','|cff71C671Won','|cffff6060Lost','|cff00E5EETotal')
	tooltip:AddLine('Battlegrounds',PvPinfo_Battlegrounds_Wins,PvPinfo_Battlegrounds_Totals-PvPinfo_Battlegrounds_Wins,PvPinfo_Battlegrounds_Totals)
	tooltip:AddLine('Rated battlegrounds',PvPinfo_RatedBattlegrounds_Wins,PvPinfo_RatedBattlegrounds_Totals-PvPinfo_RatedBattlegrounds_Wins,PvPinfo_RatedBattlegrounds_Totals)
    tooltip:AddLine(' ')
    tooltip:AddLine('|cffFFC125Arena','|cff71C671Won','|cffff6060Lost','|cff00E5EETotal')
	tooltip:AddLine('World 1v1',PvPinfo_World1vs1_Wins,PvPinfo_World1vs1_Lost,PvPinfo_World1vs1_Wins+PvPinfo_World1vs1_Lost)
	tooltip:AddLine('Arena 2v2',PvPinfo_Arena2vs2_Wins,PvPinfo_Arena2vs2_Totals-PvPinfo_Arena2vs2_Wins,PvPinfo_Arena2vs2_Totals)
	tooltip:AddLine('Arena 3v3',PvPinfo_Arena3vs3_Wins,PvPinfo_Arena3vs3_Totals-PvPinfo_Arena3vs3_Wins,PvPinfo_Arena3vs3_Totals)
	tooltip:AddLine('Arena 5v5',PvPinfo_Arena5vs5_Wins,PvPinfo_Arena5vs5_Totals-PvPinfo_Arena5vs5_Wins,PvPinfo_Arena5vs5_Totals)
    tooltip:AddLine(' ')
    tooltip:AddLine('|cffFFC125Currencies','|cff71C671Now','|cffff6060Left','|cff00E5EECap')
	tooltip:AddLine('Honor Points',PvPinfo_HonorPointsCount,((4000)-(PvPinfo_HonorPointsCount)),(4000))
	tooltip:AddLine('Conquest Points',PvPinfo_ConquestPointsCount,((5000)-(PvPinfo_ConquestPointsCount)),(5000))
	tooltip:AddLine('- Conquest Weekly',PvPinfo_ConquestCurrecy_Now,(PvPinfo_ConquestCurrecy_Cap-PvPinfo_ConquestCurrecy_Now),PvPinfo_ConquestCurrecy_Cap)
	tooltip:AddLine('- Conquest Arena',PvPinfo_ConquestArena_Now,(PvPinfo_ConquestArena_Cap)-(PvPinfo_ConquestArena_Now),PvPinfo_ConquestArena_Cap)
	tooltip:AddLine('- Conquest Rated BGs',PvPinfo_ConquestRatedBGs_Now,(PvPinfo_ConquestRatedBGs_Cap)-(PvPinfo_ConquestRatedBGs_Now),PvPinfo_ConquestRatedBGs_Cap)
	tooltip:AddLine('- Conquest Random BGs',PvPinfo_ConquestRandomBGs_Now,(PvPinfo_ConquestRandomBGs_Cap-PvPinfo_ConquestRandomBGs_Now),PvPinfo_ConquestRandomBGs_Cap)
    tooltip:AddLine(' ')
    tooltip:AddLine('|cffFFC125Miscellaneous',' ',' ','|cff00E5EETotal')
	tooltip:AddLine('Player death:',' ',' ',PvPinfo_Playerdeaths)
	tooltip:AddLine('Honor Kills:',' ',' ',PvPinfo_HonorKills)
	tooltip:AddLine('Critter Kills:',' ',' ',PvPinfo_CrittersKilled)
	tooltip:AddLine('/violin',' ',' ',PvPinfo_SlashViolin)
    tooltip:SmartAnchorTo(self)
    tooltip:Show()
end

--------------------------- function dataobj:OnLeave() ----------------------------

function dataobj:OnLeave()
    if lqt:IsAcquired("PvPInfoTT") then
        lqt:Release(self.tooltip)
        self.tooltip = nil
    end
end